
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class Cible { // information pour une cible
  String classe; // nom de la classe signal
  String nom; // nom du fichier image
  int couleur; // couleur pour le tco
  PImage image; // l'image du signal
  boolean mecanique; // le type du signal
  PaveSignal pave; // le pave associe
  
  Cible(String c,String n,int x,boolean b) { 
    classe=c; nom=n; couleur=x; mecanique=b;
  }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class PaletteSignaux extends Aide2 {
  final int BORDURE=10; // bordure de la fenetre en pixels
  final int H=339,L=178; // largeur et hauteur max des cibles
  final float zoom=0.5; // zoom des signaux  1/2
  int S=10; // separateur entre cibles (en pixels)
  //Cible[] ciblesLum,ciblesBal,ciblesMec; //Cible[] cibles;
  //int nb=max(ciblesLum.length,ciblesBal.length,ciblesMec.length);
  
  Ctrl lum=new Ctrl("lum.",true); // signaux lumineux      
  Ctrl mec=new Ctrl("mec.",false); // signaux mecaniques
  Ctrl bal=new Ctrl("bal.",false); // signaux de bal
  Controles ctrls=new Controles(0,0,0.7,lum,bal,mec); // les controles

  Cible[] ciblesLum=new Cible[] {  
    new Cible("Carre","C_C",ROUGE,false),new Cible("CarreAvertissement","C_C",ROUGE,false),
    /*new Cible("CarreRalentissement","CR_C",ROUGE,false),*/new Cible("CarreAvertissementRalentissement","CR_C",ROUGE,false),
    new Cible("CarreRappelRalentissement","CRR_C",ROUGE,false),new Cible("CarreAvertissementRappelRalentissement","CRR_C",ROUGE,false),
    new Cible("CarreViolet","Cv_Cv",VIOLET,false),new Cible("CarreVioletBas","Cvb_Cv",VIOLET,false),
    new Cible("Avertissement","A_A",JAUNE,false), new Cible("AvertissementRalentissement","AR_R",JAUNE,false),
    new Cible("Disque","D_D",ROUGE,false),new Cible("DisqueAvertissement","DA_D",ROUGE,false)
  };

  Cible[] ciblesBal=new Cible[] { //int nb=max(ciblesLum.length,ciblesBal.length,ciblesMec.length);
    new Cible("CarreBAL","C_C",ROUGE,false),new Cible("CarreRalentissementBAL","CR_C",ROUGE,false),new Cible("CarreRappelRalentissementBAL","CRR_C",ROUGE,false),
    new Cible("SemaphoreBAL","S_Vl",VERT,false),new Cible("SemaphoreAvertissementBAL","S_A",JAUNE,false),new Cible("SemaphoreAvertissementRalentissementBAL","SR_A",JAUNE,false)   
  };

  Cible[] ciblesMec=new Cible[] {  
    new Cible("Avertissement","A_A",JAUNE,true),new Cible("AvertissementRalentissement","AR_A",JAUNE,true),
    new Cible("Carre","C_C",ROUGE,true),new Cible("CarreAvertissement","CA_C",ROUGE,true),
    new Cible("CarreAvertissementRalentissement","CAR_C",ROUGE,true),
    new Cible("CarreRappelRalentissement","CRR_C",ROUGE,true),new Cible("CarreAvertissementRappelRalentissement","CARR_C",ROUGE,true),
    new Cible("CarreViolet","Cv_Cv",VIOLET,true),new Cible("Disque","D_D",ROUGE,true),
    new Cible("DisqueAvertissement","DA_D",ROUGE,true),
    new Cible("Semaphore","S_S",ROUGE,true)/*,new Cible("GuidonArret","Ga_C",ROUGE,true)*/
  };      
  
  Palette[] palettes={new Palette(BORDURE,BORDURE,zoom,ciblesLum),
                      new Palette(BORDURE,BORDURE,zoom,ciblesBal),
                      new Palette(BORDURE,BORDURE,zoom,ciblesMec)}; //new Palette[3];
  Palette palette=palettes[0];

  void settings() { int nb=max(ciblesLum.length,ciblesBal.length,ciblesMec.length);
    size((int)(L*nb*zoom)+BORDURE+BORDURE+(int)((nb-1)*S*zoom), // taille de la fenetre
         (int)(H*zoom*2)+BORDURE+BORDURE, // 1.75
         P2D); // mode graphique 2D
  }
  
  void setup() {
    noStroke(); 
    surface.setTitle("Palette signaux");
    mef(ciblesLum); mef(ciblesBal); mef(ciblesMec); 
   }
    
  void draw() { 
    background(GRIS_FOND);  
    palette.dessiner(); // affichage palette
  }
  
  void mef(Cible[] cs) { // mise des paves et des images dans les cibles
    for (Cible c : cs) { // pour toutes les cibles
      c.pave=new PaveSignal(c.couleur); // mise des paves dans les cibles
      if (c.mecanique) c.image=loadImage(path+"/Mecaniques/"+c.nom+".gif");
      else             c.image=loadImage(path+"/Lumineux/"+c.nom+".gif"); 
    }
  }
  
  void mouseClicked() { palette.clicked(mouseX,mouseY); ctrls.clicked(mouseX,mouseY-H*zoom-9*ZOOM-2*BORDURE); }
  void mouseMoved () { palette.moved(mouseX,mouseY); } 
  
/*
  abstract class Forme extends Aide2.Forme { 
    PShape s; // le contour de la forme
   
    Forme() { // constructeur
      s=createShape(); // creation de la forme
    }
  }  
*/
//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

// CLASSES INTERNE

  class Palette {
    int x,y; // position
    float zoom; // taux de zoom
        
    final int BORDURE=10; // bordure de la fenetre en pixels
    final int H=339,L=178; // largeur et hauteur max des cibles
    int S=10; // separateur entre cibles (en pixels)
  
    String texte;
    Cible cible;
    Cible[] cibles;
    int nb; 
    PaveSignal pave;
  
    Palette(int x,int y,float z,Cible[] cs) {// constructeur 
      this.x=x; this.y=y; zoom=z; cibles=cs; nb=cibles.length; ;
    } 
  
    void dessiner() { int i; PImage img;
      pushMatrix();
      translate(x,y); 
      
      pushMatrix();
      fill(0); textSize(50*zoom); textAlign(LEFT,TOP);// texte noir
      translate(0,H*zoom+BORDURE+9*ZOOM);
      if (cible!=null) text(cible.classe,275,0); //
      textSize(40*zoom); text(affichage(),0,50); 
      ctrls.dessiner();
      popMatrix();
  
      for (i=0; i<nb; i++) { // pour toutes les cibles
        img=cibles[i].image; 
        pushMatrix();
        translate(i*(L*zoom+S*zoom),0); 
        stroke(0); noFill(); rect(0,0,L*zoom,H*zoom+9*ZOOM); // grand rectangle
        
        pushMatrix(); translate((L*zoom-9*ZOOM)/2.0,H*zoom); scale(ZOOM);
        cibles[i].pave.dessiner(); // pave
        popMatrix();
        
        scale(zoom); // zoom
        image(img,(L-img.width)/2,(H-img.height)); // cible
        popMatrix();
      }
      popMatrix();
    }
  
    void clicked(float mx,float my) { int i; 
      if (mx<x || my<y || mx>x+(nb-1)*S*zoom+nb*L*zoom || my>y+H*zoom+9*ZOOM) return;
      for (i=0; i<nb; i++) {
        if (!(mx<x+(i*(L+S))*zoom || mx>x+(i*(L+S)+L)*zoom)) { 
          if (mouseButton==LEFT) cibles[i].pave.rotation();
          if (mouseButton==RIGHT) cibles[i].pave.symetrie();
          cible=cibles[i]; 
          if (cible.pave!=null) clipboard.setContents(new java.awt.datatransfer.StringSelection(affichage()),null);
          return; 
        }
      }
    }
    
    void moved(float mx,float my) { int i; 
      if (mx<x || my<y || mx>x+(nb-1)*S*zoom+nb*L*zoom || my>y+H*zoom+9*ZOOM) return;
      for (i=0; i<nb; i++) {
        if (!(mx<x+(i*(L+S))*zoom || mx>x+(i*(L+S)+L)*zoom)) { 
         cible=cibles[i]; //pave.colorer(cible.couleur);
         if (cible.pave!=null) clipboard.setContents(new java.awt.datatransfer.StringSelection(affichage()),null);
         return; 
        }
      }
    }
    
    String affichage() { String r="new PaveSignal(new "; // string worker ?
      if (cible==null) return "";
      r+=cible.classe;
      r+="()";
      if (cible.mecanique) r+=".mecanique()";
      r+=")";
      if (cible.pave.sym) r+=".symetrie()";
      if (cible.pave.rot==1) r+=".rotation()"; 
      //println(cible);println(cible.pave);println(cible.pave.rot);
      if (cible.pave.rot>=2) r+=".rotation("+cible.pave.rot+")";
      r+=";";  //println(r);
      return r; 
    }
  }

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  class Ctrl { // pour les boutons de choix de sous-palette
    String nom;
    boolean on;
    //int nb;
    
    Ctrl(String s,boolean b) { nom=s; on=b; }
    //Ctrl(String s,int n) { nom=s; nb=n; }
  }

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //
  
  class Controles {
    int S=20; // separation entre les boutons
    int L=100,H=50; // largeur hauteur des boutons
    int nb; // nombre de boutons
    String texte=null; // texte des messages
    int couleur=0; // la couleur des messages
    
    int GRIS=#AAAAAA,BLEU=#00B4FA; // couleurs
    int x,y; // position
    float zoom; // taux de zoom
    Bouton[] boutons;
    
    Controles(int x,int y,float z,Ctrl... cs) { int i; // constructeur (n boutons)
      this.x=x; this.y=y; zoom=z; nb=cs.length;
      boutons=new Bouton[nb];
      for (i=0; i<nb; i++) { boutons[i]=new Bouton(cs[i]); }
    }
    
    void dessiner() { Bouton b; int i;  // centrage  y1 y2
      pushMatrix();
      translate(x,y); 
      scale(zoom);
      fill(GRIS);
      for (i=0; i<nb; i++)  {
        b=boutons[i];
        pushMatrix();
        translate(i*(L+S),0); 
        b.dessiner();
        popMatrix();
      }
      if (texte!=null) {
        pushMatrix();
        translate(nb*(L+S),0); 
        noStroke(); fill(couleur);
        rect(0,0,textWidth(texte)*zoom*ZOOM*2,H,10); // revoir !!!
        fill(0); // noir
        scale(4); textAlign(LEFT,CENTER);
        text(texte,0,4.5); //  corriger 4.5 !!! ???   voir bouton
        popMatrix();
      }
      popMatrix();
    }
  
    void clicked(float mx,float my) { int i; //Bouton b;  
      if (mx<x || my<y || mx>x+(nb-1)*S*zoom+nb*L*zoom || my>y+H*zoom) return;
      for (i=0; i<nb; i++) {
        if (!(mx<x+(i*(L+S))*zoom || mx>x+(i*(L+S)+L)*zoom)) { 
          for (Bouton b : boutons) b.ctrl.on=false; // raz de tous les boutons
          boutons[i].ctrl.on=true; palette=palettes[i]; return;  // selection du bon bouton
        }
      }
    }
  
    // classe interne interne
    
    class Bouton { 
      Ctrl ctrl; 
     
      Bouton(Ctrl c) { ctrl=c; }
      
      void dessiner() { 
        if (ctrl.on) fill(BLEU); else fill(GRIS);
        rect(0,0,L,H,10);
        fill(0); // noir
        translate(L/2,H/2-5);
        scale(1.5);
        textAlign(CENTER,CENTER);
        //textSize(40);
        text(ctrl.nom,0,0);
      }
    }
  }

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

} // fin palette signaux

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////