
// LE TCO

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class TCO {
  Pave[][] paves=new Pave[COLONNES][LIGNES]; // les cases du tco
  
  int c=0,l=0; // pour la construction
 
  TCO() { construire(); } // constructeur
 
  void alaligne() { l++; c=0; assert l<LIGNES; } // aller a la ligne
  
  void espacer() { c++; assert c<COLONNES; } // espacement   
  void espacer(int n) { c=c+n; assert c<COLONNES; } // espacement multiple
  
  void ajouter(Pave p) { // ajout d'un pave 
    paves[c][l]=p;
    c+=p.taille; assert c<COLONNES; // avancement fonction de la taille du pave
  }
  
  void dessiner() { int l,c; Pave p;
    translate(BORDURE,BORDURE); // decalage pour la bordure
    for (l=0; l<LIGNES; l++) for (c=0; c<COLONNES; c++) { // dessin de la grille
      stroke(NOIR); noFill(); // bordure noire 1 pixel, pas de remplissage
      rect(c*TAILLE_CASE*ZOOM,l*TAILLE_CASE*ZOOM,TAILLE_CASE*ZOOM,TAILLE_CASE*ZOOM); // dessin d'un carre vide
    }
    noStroke(); // pas de bordure
    scale(ZOOM,ZOOM); // zoom des paves
    for (l=0; l<LIGNES; l++) for (c=0; c<COLONNES; c++) { // dessin des paves
      p=paves[c][l]; // un des paves
      if (p!=null) {
        pushMatrix(); // sauvegarde des transformations
        translate(c*TAILLE_CASE,l*TAILLE_CASE); // placement du pave dans la bonne case
        p.dessiner(); // dessin du pave
        popMatrix(); // restauration des transformations
      }
    }
  } 

  
//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //
/*
  void construire() { // test coeur
    alaligne(); espacer();
    ajouter(new PaveDroit()); 
    ajouter(new PaveAiguilleDroite().symetrie().rotation(2)); 
    ajouter(new PaveAiguilleDroite().rotation(2)); 
    ajouter(new PaveDroit()); 
    alaligne(); 
    
    espacer();
    ajouter(new PaveDroit()); 
    ajouter(new PaveAiguilleDroite()); 
    ajouter(new PaveAiguilleDroite().symetrie()); 
    ajouter(new PaveDroit()); espacer(); ajouter(new PaveBiais().retraitSudOuest()); 
    alaligne(); 
    espacer(2); ajouter(new PaveDroit().retraitEst()); ajouter(new PaveDroit().retraitOuest()); 
                espacer(); ajouter(new PaveBiais().retraitNordEst());
    alaligne(); 
    
    espacer();
    ajouter(new PaveDroit()); 
    //ajouter(new PaveJonction(false,new PaveAiguilleDroite().symetrie().rotation(2),new PaveAiguilleDroite().rotation(2)));
    ajouter(new PaveJonctions(new PaveAiguilleDroite().symetrie().rotation(2),new PaveAiguilleDroite().rotation(2),
                              new PaveAiguilleDroite(),                       new PaveAiguilleDroite().symetrie()));
    ajouter(new PaveDroit()); 
    alaligne(); espacer();
    ajouter(new PaveDroit()); 
    espacer(2); 
    //ajouter(new PaveJonction(true,new PaveAiguilleDroite(),new PaveAiguilleDroite().symetrie()));
    ajouter(new PaveDroit()); 
    alaligne(); alaligne(); 
    
    espacer();
    ajouter(new PaveDroit()); 
    ajouter(new PaveJonctions(new PaveAiguilleDroite().symetrie().rotation(2),new PaveTJS(),
                              new PaveTJD(),new PaveAiguilleBiaise().symetrie().manoeuvrer()));
    ajouter(new PaveDroit()); 
    alaligne(); espacer();
    ajouter(new PaveDroit()); 
    espacer(2); 
    //ajouter(new PaveDroit()); 
    alaligne(); espacer(4); ajouter(new PaveBiais().symetrie()); 
    
    // en biais pas possible
 }
*/
/*  
  void construire() { // test signaux
    alaligne(); alaligne(); espacer();
    ajouter(new PaveSignal(new Carre())); ajouter(new PaveSignal(new CarreAvertissement())); 
    //ajouter(new PaveSignal(new CarreRalentissement())); 
    ajouter(new PaveSignal(new CarreAvertissementRalentissement())); 
    ajouter(new PaveSignal(new CarreRappelRalentissement())); ajouter(new PaveSignal(new CarreAvertissementRappelRalentissement())); 
    ajouter(new PaveSignal(new CarreViolet())); ajouter(new PaveSignal(new CarreVioletBas())); 
    ajouter(new PaveSignal(new Avertissement())); ajouter(new PaveSignal(new AvertissementRalentissement())); 
    ajouter(new PaveSignal(new Disque())); ajouter(new PaveSignal(new DisqueAvertissement())); 
    alaligne(); alaligne(); espacer();
    ajouter(new PaveSignal(new CarreBAL())); ajouter(new PaveSignal(new CarreRalentissementBAL())); ajouter(new PaveSignal(new CarreRappelRalentissementBAL())); 
    ajouter(new PaveSignal(new SemaphoreBAL())); ajouter(new PaveSignal(new SemaphoreAvertissementBAL())); ajouter(new PaveSignal(new SemaphoreRalentissementBAL()));
    alaligne(); alaligne(); espacer();
    ajouter(new PaveSignal(new Carre().mecanique())); 
    ajouter(new PaveSignal(new CarreAvertissement().mecanique())); 
    ajouter(new PaveSignal(new CarreAvertissementRalentissement().mecanique())); 
    ajouter(new PaveSignal(new CarreRappelRalentissement().mecanique())); 
    ajouter(new PaveSignal(new CarreAvertissementRappelRalentissement().mecanique())); 
    ajouter(new PaveSignal(new CarreViolet().mecanique())); 
    ajouter(new PaveSignal(new Avertissement().mecanique())); ajouter(new PaveSignal(new AvertissementRalentissement().mecanique())); 
    ajouter(new PaveSignal(new Disque().mecanique())); ajouter(new PaveSignal(new DisqueAvertissement().mecanique())); 
    ajouter(new PaveSignal(new Semaphore().mecanique()));  
}
*/

  void construire() { // construction tco ipcs
  alaligne(); espacer();
  ajouter(new PaveBiSens());
  ajouter(new PaveSignal(ROUGE).retraitEst());  
  ajouter(new PaveDroit().retraitOuest());
  ajouter(new PaveAiguilleDroite().symetrie().rotation(2).retraitSudEst());
  ajouter(new PaveDroitLong(3)); 
  ajouter(new PaveAiguilleDroite().rotation(2).retraitSudOuest());
  ajouter(new PaveDroit().retraitEst());
  ajouter(new PaveSignal(ROUGE).rotation(2).retraitOuest());
  ajouter(new PaveBiSens());
  alaligne(); espacer();
  
  ajouter(new PaveBiSens());
  ajouter(new PaveSignal(ROUGE).retraitEst());
  ajouter(new PaveDroit().retraitOuest());
  ajouter(new PaveDroit());
  ajouter(new PaveAiguilleDroite().symetrie().retraitNordOuest());
  ajouter(new PaveDroit());
  ajouter(new PaveAiguilleDroite().retraitNordEst());
  ajouter(new PaveDroit());
  ajouter(new PaveDroit().retraitEst());
  ajouter(new PaveSignal(ROUGE).rotation(2).retraitOuest());
  ajouter(new PaveBiSens());
}

/*
  void construire() { int l=1,c=1; // tests affichages
    paves[c++][l]=new PaveDroit(); c++; paves[c++][l]=new PaveBiais(); c++; paves[c++][l]=new PaveArc45(); c++;
    paves[c++][l]=new PaveAiguilleDroite(); c++; paves[c++][l]=new PaveAiguilleBiaise(); c++; paves[c++][l]=new PaveAiguilleSymetrique(); c++;
    paves[c++][l]=new PaveTJD(); c++; paves[c++][l]=new PaveTJS(); c++; paves[c++][l]=new PaveAiguilleTriple(); c++; 
    paves[c++][l]=new PaveCroisementDroitDroit(); c++; paves[c++][l]=new PaveCroisementDroitBiais(); c++; paves[c++][l]=new PaveCroisementBiaisBiais(); c++; 
  }    
*/
/*
  void construire() { // 10 12   bif. du mont de terre
    alaligne();
    espacer(8); ajouter(new PaveArc45().rotation(2).retraitEst()); ajouter(new PaveDroit().retraitOuest()); ajouter(new PaveSens()); 
    alaligne();
    espacer(); ajouter(new PaveBiSens()); ajouter(new PaveSignal(new CarreRappelRalentissement()).retraitEst()); ajouter(new PaveArc45().symetrie().rotation(2).retraitOuest()); espacer(3); 
               ajouter(new PaveBiais()); ajouter(new PaveArc45().rotation(2).retraitEst()); ajouter(new PaveSignal(new Carre()).rotation(2).retraitOuest()); ajouter(new PaveSens().symetrie()); 
    alaligne();
    espacer(); ajouter(new PaveSens()); ajouter(new PaveSignal(new CarreRappelRalentissement()).retraitEst()); ajouter(new PaveDroit().retraitOuest()); 
               ajouter(new PaveTJS().symetrie().retraitSudEst()); ajouter(new PaveDroit()); ajouter(new PaveAiguilleDroite().retraitEst());  
               ajouter(new PaveCroisementDroitBiais().retraitOuest().retraitSudOuest());
               ajouter(new PaveDroit().retraitEst()); ajouter(new PaveDroit().retraitOuest()); ajouter(new PaveSens()); 
    alaligne();
    espacer(); ajouter(new PaveSens().symetrie()); ajouter(new PaveDroit().retraitEst()); ajouter(new PaveDroit().retraitOuest()); ajouter(new PaveDroit());
               ajouter(new PaveAiguilleDroite().symetrie().retraitNordOuest()); ajouter(new PaveAiguilleDroite().retraitNordEst()); ajouter(new PaveDroit()); 
               ajouter(new PaveDroit().retraitEst()); ajouter(new PaveSignal(new CarreRappelRalentissement()).rotation(2).retraitOuest()); ajouter(new PaveSens().symetrie());                
  }  
*/
/*
  void construire() { // grands arcs 90°
    //alaligne();
    //espacer(); ajouter(new PaveArc90Grand(6));
    alaligne();
    espacer(); ajouter(new PaveArc90Grand(5));
    alaligne();
    espacer(); ajouter(new PaveArc90Grand(4));
    alaligne();
    espacer(); ajouter(new PaveArc90Grand(3));
    alaligne();
    espacer(); ajouter(new PaveArc90Grand(2));
    alaligne();
    espacer(); ajouter(new PaveArc90Grand(1));
  }
  */
/*  
  void construire() { // exemple2 4 paves rajoutes
    alaligne();
    espacer(); ajouter(new PaveButoirDroit());
    espacer(); ajouter(new PaveButoirBiais());
    espacer(); ajouter(new PaveSens());
    espacer(); ajouter(new PaveBiSens());
  }
*/  
  
} // fin tco

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////