
// Fabrication de TCOs pour l'article "TCOs en Processing"
// version 2.0 du 11 janvier 2018
// Pierre Lecouffe

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// CONSTANTES

int LIGNES=10,COLONNES=20; // nombre de lignes et de colonnes ipcs signaux

final int TAILLE_CASE=9; // cote d'une case en pixels
final int BORDURE=10; // bordure de la fenetre en pixels
final int ZOOM=5; // taux de zoom

final static int GRIS_FOND=#D3D3D3,GRIS=#7F7F7F,NOIR=#000000,GRIS_FONCE=#555555; // couleurs
final static int ROUGE=#FF0000,VIOLET=#FF00FF,BLANC=#FFFFFF,JAUNE=#FFFF00,VERT=#00FF00; // couleur pour signaux

// VARIABLES

TCO tco; // le tco

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void settings() {
  size(COLONNES*TAILLE_CASE*ZOOM+BORDURE+BORDURE, // taille de la fenetre
       LIGNES*TAILLE_CASE*ZOOM+BORDURE+BORDURE,
       P2D); // mode graphique 2D
}

void setup() {
  noStroke(); // pas de bordures sur les formes
  surface.setTitle("IPCS"); // nom de la fenetre
  tco=new TCO(); // le tco
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void draw() {
  background(GRIS_FOND); // couleur du fond
  tco.dessiner(); // dessin du tco
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void mouseClicked() { int l,c; ; Pave p;                              
  l=(mouseY-BORDURE)/TAILLE_CASE/(int)ZOOM; // calcul de la ligne
  c=(mouseX-BORDURE)/TAILLE_CASE/(int)ZOOM; // calcul de la colonne
  if (l<0 || l>=LIGNES || c<0 || c>=COLONNES) return; // pas dans tco  
  p=tco.paves[c][l]; // obtension du pave
  if (p!=null) p.manoeuvrer(mouseButton==RIGHT); // manoeuvre des aiguilles et signaux
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

PaveSignal paveSignalSelectionne=null;

void mouseMoved() { int l,c; ; Pave p; 
  //println(hex(get(mouseX,mouseY)));
  l=(mouseY-BORDURE)/TAILLE_CASE/(int)ZOOM; // calcul de la ligne
  c=(mouseX-BORDURE)/TAILLE_CASE/(int)ZOOM; // calcul de la colonne
  if (l<0 || l>=LIGNES || c<0 || c>=COLONNES) return; // pas dans tco  
  p=tco.paves[c][l]; // obtension du pave
  if (p==null || !(p instanceof PaveSignal)) { paveSignalSelectionne=null; return; }
  paveSignalSelectionne=(PaveSignal)p;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////